[PATCH 1/3] ipip6: add new package for IPIP6(RFC2473) support Add Generic Packet Tunneling in IPv6 Specification (RFC 2473) support. (For NTT Broadband V6Plus/transix/Xpass Fixed IP)
ms at missing233.com
ms at missing233.com
Mon Feb 12 09:01:14 PST 2024
From: Arayuki Mago <ms at missing233.com>
Signed-off-by: Arayuki Mago <ms at missing233.com>
---
package/network/ipv6/ipip6/Makefile | 44 +++++++++
package/network/ipv6/ipip6/files/ipip6.sh | 106 ++++++++++++++++++++++
2 files changed, 150 insertions(+)
create mode 100644 package/network/ipv6/ipip6/Makefile
create mode 100644 package/network/ipv6/ipip6/files/ipip6.sh
diff --git a/package/network/ipv6/ipip6/Makefile b/package/network/ipv6/ipip6/Makefile
new file mode 100644
index 0000000000..034f17e0c0
--- /dev/null
+++ b/package/network/ipv6/ipip6/Makefile
@@ -0,0 +1,44 @@
+#
+# Copyright (C) 2013 OpenWrt.org
+# Copyright (C) 2021 kenjiuno
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+include $(TOPDIR)/rules.mk
+
+PKG_NAME:=ipip6
+PKG_VERSION:=0.1
+PKG_RELEASE:=6
+PKG_LICENSE:=GPL-2.0
+PKG_MAINTAINER:=kenjiuno
+
+include $(INCLUDE_DIR)/package.mk
+
+define Package/ipip6
+ SECTION:=net
+ CATEGORY:=Network
+ DEPENDS:=@IPV6 +kmod-ip6-tunnel +resolveip
+ TITLE:=IPv4 over IPv6 (RFC2473) configuration support
+ MAINTAINER:=kenjiuno <ku at digitaldolphins.jp>
+ PKGARCH:=all
+endef
+
+define Package/ipip6/description
+Provides support for IPv4 over IPv6 (RFC2473) in /etc/config/network.
+endef
+
+define Build/Compile
+endef
+
+define Build/Configure
+endef
+
+define Package/ipip6/install
+ $(INSTALL_DIR) $(1)/lib/netifd/proto
+ $(INSTALL_BIN) ./files/ipip6.sh $(1)/lib/netifd/proto/ipip6.sh
+
+endef
+
+$(eval $(call BuildPackage,ipip6))
diff --git a/package/network/ipv6/ipip6/files/ipip6.sh b/package/network/ipv6/ipip6/files/ipip6.sh
new file mode 100644
index 0000000000..ceadf71f67
--- /dev/null
+++ b/package/network/ipv6/ipip6/files/ipip6.sh
@@ -0,0 +1,106 @@
+#!/bin/sh
+# ipip6.sh - ipip6 tunnel(RFC2473) backend
+# Copyright (c) 2013 OpenWrt.org
+# Copyright (c) 2021 kenjiuno
+
+[ -n "$INCLUDE_ONLY" ] || {
+ . /lib/functions.sh
+ . /lib/functions/network.sh
+ . ../netifd-proto.sh
+ init_proto "$@"
+}
+
+proto_ipip6_setup() {
+ local cfg="$1"
+ local iface="$2"
+ local link="ipip6-$cfg"
+ local remoteip6
+
+ local mtu ttl peeraddr ip6addr tunlink zone weakif encaplimit ip4ifaddr
+ json_get_vars mtu ttl peeraddr ip6addr tunlink zone weakif encaplimit ip4ifaddr
+
+ [ -z "$peeraddr" ] && {
+ proto_notify_error "$cfg" "MISSING_ADDRESS"
+ proto_block_restart "$cfg"
+ return
+ }
+
+ ( proto_add_host_dependency "$cfg" "::" "$tunlink" )
+
+ remoteip6=$(resolveip -6 "$peeraddr")
+ if [ -z "$remoteip6" ]; then
+ sleep 3
+ remoteip6=$(resolveip -6 "$peeraddr")
+ if [ -z "$remoteip6" ]; then
+ proto_notify_error "$cfg" "AFTR_DNS_FAIL"
+ return
+ fi
+ fi
+
+ for ip6 in $remoteip6; do
+ peeraddr=$ip6
+ break
+ done
+
+ [ -z "$ip6addr" ] && {
+ local wanif="$tunlink"
+ if [ -z "$wanif" ] && ! network_find_wan6 wanif; then
+ proto_notify_error "$cfg" "NO_WAN_LINK"
+ return
+ fi
+
+ if ! network_get_ipaddr6 ip6addr "$wanif"; then
+ [ -z "$weakif" ] && weakif="lan"
+ if ! network_get_ipaddr6 ip6addr "$weakif"; then
+ proto_notify_error "$cfg" "NO_WAN_LINK"
+ return
+ fi
+ fi
+ }
+
+ proto_init_update "$link" 1
+ proto_add_ipv4_route "0.0.0.0" 0
+ proto_add_ipv4_address "$ip4ifaddr" "" "" "0.0.0.0"
+
+ proto_add_tunnel
+ json_add_string mode ipip6
+ json_add_int mtu "${mtu:-1280}"
+ json_add_int ttl "${ttl:-64}"
+ json_add_string local "$ip6addr"
+ json_add_string remote "$peeraddr"
+ [ -n "$tunlink" ] && json_add_string link "$tunlink"
+ json_add_object "data"
+ [ -n "$encaplimit" ] && json_add_string encaplimit "$encaplimit"
+ json_close_object
+ proto_close_tunnel
+
+ proto_add_data
+ [ -n "$zone" ] && json_add_string zone "$zone"
+
+ proto_close_data
+
+ proto_send_update "$cfg"
+}
+
+proto_ipip6_teardown() {
+ local cfg="$1"
+}
+
+proto_ipip6_init_config() {
+ no_device=1
+ available=1
+
+ proto_config_add_string "ip6addr"
+ proto_config_add_string "peeraddr"
+ proto_config_add_string "tunlink"
+ proto_config_add_int "mtu"
+ proto_config_add_int "ttl"
+ proto_config_add_string "encaplimit"
+ proto_config_add_string "zone"
+ proto_config_add_string "weakif"
+ proto_config_add_string "ip4ifaddr"
+}
+
+[ -n "$INCLUDE_ONLY" ] || {
+ add_protocol ipip6
+}
--
2.40.1.windows.1
More information about the openwrt-devel
mailing list